var ql = require('../ql'),
	_ = require('lodash'),
	JSPath = require('jspath');

module.exports = _.defaults({
	name: 'jspath',

	query: function query(source, query, opts, callback) {
		var substs = opts.substs;

		// replace ' with "
		query = query.replace(/\'/g, '"');

		// expand Ti. > Titanium.
		query = query.replace(/"Ti\./g, '"Titanium.');

		// replace Ti.UI.backgroundColor with Ti.UI(.properties|.events|.methods).{.name==="backgroundColor"}
		query = query.replace(/^\."((?:[A-Z][a-zA-Z]*\.)+)([a-z][a-zA-Z]*)"/, function (match, p1, p2) {
			return '."' + p1.substr(0, p1.length - 1) + '"(.properties|.events|.methods).{.name==="' + p2 + '"}';
		});

		var result;

		try {
			result = JSPath.apply(query, source, substs);
		} catch (err) {
			return callback(err.message);
		}

		callback(null, result);
	}

}, ql);
