var jspathQL = require('./jspath'),
	_ = require('lodash');

var VALID_JSPATH_STEP = /^[a-z0-9]+(_[a-z0-9])*$/i;

module.exports = _.defaults({
	name: 'path',

	query: function query(source, query, opts, callback) {
		var pathSteps = query.split('/');
		var jsPathSteps = [''];

		_.each(pathSteps, function (step, index) {

			// skip part before or after trailing /
			if (step === '' && (index === 0 || index === pathSteps.length - 1)) {
				return;
			}

			// wrap non-alphanumeric parts with . in "", except *
			if (step !== '' && step !== '*' && !VALID_JSPATH_STEP.test(step)) {
				step = '"' + step + '"';
			}

			jsPathSteps.push(step);
		});

		query = jsPathSteps.join('.');

		jspathQL.query(source, query, opts, callback);
	}

}, jspathQL);
